//---------------------------------------------------------------------------
#pragma hdrstop

#include "Global2.h"
#include "RemailerDocs2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

__fastcall TRemailerDoc::TRemailerDoc(TRichEdit *Doc)
   : TObject()
{
   Name = "generic";
   Lines = Doc->Lines;
   ed = Doc;
}
//---------------------------------------------------------------------------

__fastcall TRemailerDoc::~TRemailerDoc()
{
   delete Doc;
}
//---------------------------------------------------------------------------

bool __fastcall TRemailerDoc::IsValid()
{
   return true;
}
//---------------------------------------------------------------------------

bool __fastcall TRemailerDoc::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------
// mlist.txt
//---------------------------------------------------------------------------

__fastcall TMixMListTxt::TMixMListTxt(TRichEdit *doc)
   : TRemailerDoc(doc)
{
   Name = "mlist.txt";
}
//---------------------------------------------------------------------------

bool __fastcall TMixMListTxt::IsValid()
{
   return Doc->Lines->IndexOf("mixmaster           history  latency  uptime") > 0;
}
//---------------------------------------------------------------------------

bool __fastcall TMixMListTxt::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------
// pubring.mix
//---------------------------------------------------------------------------

__fastcall TMixPubringMix::TMixPubringMix(TRichEdit *doc)
   : TRemailerDoc(doc)
{
   Name = "pubring.mix";
}
//---------------------------------------------------------------------------

bool __fastcall TMixPubringMix::IsValid()
{
   return Doc->Lines->IndexOf("-----Begin Mix Key-----");
}
//---------------------------------------------------------------------------

bool __fastcall TMixPubringMix::IsTooOld()
{
   return false;
}
//---------------------------------------------------------------------------
// type2.list
//---------------------------------------------------------------------------

__fastcall TMixType2List::TMixType2List(TRichEdit *doc)
   : TRemailerDoc(doc)
{
   Name = "type2.list";
}
//---------------------------------------------------------------------------

bool __fastcall TMixType2List::IsValid()
{
   bool ok = true;
   TStrings *lines = Doc->Lines;
   TrimNulls(lines);
   for (int i = 0; i < lines->Count; i++)
   {
      if (GetTok(1, lines->Strings[i], ' ').Pos("@") == 0)
      {
         ok = false;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall TMixType2List::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------
// rlist.txt
//---------------------------------------------------------------------------

__fastcall TCpkRListTxt::TCpkRListTxt(TRichEdit *doc)
   : TRemailerDoc(doc)
{
   Name = "rlist.txt";
}
//---------------------------------------------------------------------------

bool __fastcall TCpkRListTxt::IsValid()
{
   return Doc->Lines->IndexOf("remailer  email address                        history  latency  uptime") > 0;
}
//---------------------------------------------------------------------------

bool __fastcall TCpkRListTxt::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------
// pubring.asc
//---------------------------------------------------------------------------

__fastcall TCpkPubringAsc::TCpkPubringAsc(TRichEdit *doc)
   : TRemailerDoc(doc)
{
   Name = "pubring.asc";
}
//---------------------------------------------------------------------------

bool __fastcall TCpkPubringAsc::IsValid()
{
   return Doc->Lines->IndexOf("-----BEGIN PGP PUBLIC KEY BLOCK-----") >= 0;
}
//---------------------------------------------------------------------------

bool __fastcall TCpkPubringAsc::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------
// sdvisory.txt
//---------------------------------------------------------------------------

__fastcall TQSAdvisoryTxt::TQSAdvisoryTxt(TRichEdit *Doc)
   : TRemailerDoc(Doc)
{
   Name = "advisory.txt";
}
//---------------------------------------------------------------------------

bool __fastcall TQSAdvisoryTxt::IsTooOld()
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TQSAdvisoryTxt::IsValid()
{
   return true;
}

//---------------------------------------------------------------------------
// statsurls.txt
//---------------------------------------------------------------------------

__fastcall TQSUrlsTxt::TQSUrlsTxt(TRichEdit *Doc)
   : TRemailerDoc(Doc)
{
   Name = "urls.txt";
}

//---------------------------------------------------------------------------
bool __fastcall TQSUrlsTxt::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------
bool __fastcall TQSUrlsTxt::IsValid()
{
   return true;
}

//---------------------------------------------------------------------------
// nymservers.asc
//---------------------------------------------------------------------------

__fastcall TQSNymServerAsc::TQSNymServerAsc(TRichEdit *Doc)
   : TRemailerDoc(Doc)
{
   Name = "nymserver.asc";
}

//---------------------------------------------------------------------------

bool __fastcall TQSNymServerAsc::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------

bool __fastcall TQSNymServerAsc::IsValid()
{
   return true;
}

//---------------------------------------------------------------------------
// fromheader.txt
//---------------------------------------------------------------------------

__fastcall TQSFromHeadTxt::TQSFromHeadTxt(TRichEdit *Doc)
   : TRemailerDoc(Doc)
{
   Name = "fromheader.txt";
}
//---------------------------------------------------------------------------

bool __fastcall TQSFromHeadTxt::IsTooOld()
{
   return false;
}

//---------------------------------------------------------------------------

bool __fastcall TQSFromHeadTxt::IsValid()
{
   return true;
}
//---------------------------------------------------------------------------

